﻿using NDB.Extensions.Http;
using NetworkResurrector.Agent.PublishedLanguage.Commands;
using NetworkResurrector.Agent.PublishedLanguage.Events;
using NetworkResurrector.Agent.Wrapper.Constants;
using System;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Threading.Tasks;

namespace NetworkResurrector.Agent.Wrapper.Services
{
    internal class ResurrectorAgentService : IResurrectorAgentService
    {
        private const string _contentType = "application/json";
        private readonly HttpClient _httpClient;

        public ResurrectorAgentService(HttpClient httpClient)
        {
            httpClient.BaseAddress = new Uri("");
            httpClient.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue(_contentType));

            _httpClient = httpClient;
        }

        public async Task<ShutdownResult> Shutdown(string ipAddressOrMachineName)
        {
            var body = new Shutdown();
            var result = await _httpClient.ExecutePostRequest<ShutdownResult, Shutdown>(ApiRoutes.Shutdown, body);
            return result;
        }
    }
}
